{!$DEFINE DBFunctions} //       
{!$DEFINE TimeCount} //      
{!$DEFINE Main} //     Main(Form1),  ,   WriteEvent  
{$DEFINE ReOpeningJournalFile} //          
unit JohnUtil;

interface
uses Windows, Classes, SysUtils, StrUtils, Graphics, ComCtrls, ExtCtrls, FileUtil, Forms
     {$IFDEF DBFunctions}, DB, DBTables{$ENDIF};

type
  TByteRec = record
    Lo, Hi: Byte;
  end;
  TWordRec = record
    Lo, Hi: Word;
  end;
const
  SMessageHeader = '...';
  SErrorHeader = ' !';
  SOptionNotRealised = '    ...';
  SSunday = '';
  SMonday = '';
  STuesday = '';
  SWednesday = '';
  SThursday = '';
  SFriday = '';
  SSaturday = '';
  SJanuary = '';
  SFebruary = '';
  SMarch = '';
  SApril = '';
  SMay = '';
  SJun = '';
  SJuly = '';
  SAugust = '';
  SSeptember = '';
  SOctober = '';
  SNovember = '';
  SDecember = '';
  SOfYear = ' ';
  SShortDay = '';
  SShortHour = '';
  SShortMinute = '';
  SShortSecond = '';
  Minute = 1 / (24 * 60);
  Second = Minute / 60;
  MilliSecond = Second / 1000;
  MaxXSize=800; MaxYSize=600;
  Mb = 1048576;
  JournalFileName = 'Journal.txt';
  {$IFDEF DBFunctions}
    NullDir='NullBases\';          //     ( ) 
    SRecoverCopyError = '  ,     ';
    SRecoverError = '   ,   ';
    SNotFoundNullBasesDirectory = '   ''%s''    !';
  {$ENDIF}
var
  BaseDir: String='';
  WaitChar: Char; WaitKey: Word; WaitShift: TShiftState; WaitFlag: Boolean=False;
  ExitFlag: Boolean=False;
  JournalFile: TextFile;
  TimeCount: Boolean={$IFDEF TimeCount}True{$ELSE}False{$ENDIF};
  TimeProc: array[1..10,1..30] of String; // Element[LevelNum,ProcInLevelNum] -     
  TimeArray: array[1..10,1..30,0..8] of Longint; // Element[LevelNum,ProcInLevelNum,SliceTime/
                                                 // CumulativeTime/CumulativeTimeWithoutChilds/
                                                 // RunTimes/MinTime/MaxTime/ChildsTime]
  TimeLevel: Integer=0;                          //      
  TimeThread: array[1..10] of Integer;           //       

procedure SoundOff;
procedure SoundOn;
procedure AsmBeep(Frequency: Word; Interval: Word);
procedure BeBeep(N: Integer);
function RMin(A,B: Real): Real;
function RMax(A,B: Real): Real;
procedure Mes(S: String);
procedure Error(S: String);
procedure NotRealised;
function iif(Flag: Boolean; Expr1,Expr2: Variant): Variant;
function LStr(S:String; Len:Integer): String;
function RStr(S:String; Len:Integer): String;
function Sign(N: Integer): Integer;
function Date2Str(Date: TDateTime): String;
function Date2DayOfWeek(Date: TDateTime): String;
function AStr(N:LongInt; Len:Integer): String;
function Zero(N:LongInt; Len:Integer): String;
function TimeToScreen(D:Integer; T:LongInt): String;
function DiskFreeSpace(D: String): LongInt;
function GetIDE_ID: DWord;
function CaseOf(I: Integer; T1,T2,T3,T4: TObject): TObject;
procedure ExChange(var A,B: Pointer);
function GetChar: Char;
function GetKey: Word;
procedure DebugMes(S: String);
function Revert(B: Byte): Byte;
procedure AddFilterString(var F: String; S: String);
function RealToStr(R: Real; N, P: Integer): String;
function Sub(A,B: DWord): Longint;
function ByteToStr(Value: Byte): String;
procedure BitmapToPaintBox(BMP: TBitmap; PB: TPaintBox);
function ToColor5(W: Word):Byte;
function FromColor5(B: Byte):Word;
function Color2Gray(C:TColor):Byte;
function Gray2Color(C:Byte):TColor;
function RusString(S: String): String;
function Crypt(IntKey: LongInt; StrKey, S: String): String;
procedure TestBitmapEquivalence(BMP1,BMP2: TBitmap);
function BitmapIsEmpty(BMP: TBitmap): Boolean;
procedure CopyBitmap(SourceBMP, DestBMP: TBitmap);
procedure SetRus;
procedure SetEng;
procedure ClearTimeArray;
procedure ProcEnter(ProcName: String);
procedure ProcExit(ProcName: String);
procedure ShowTimeArray(M: TRichEdit);
procedure AppendLog(S: String);
procedure CopyDir(SrcDir,DestDir: String);
{$IFDEF DBFunctions}
function NullFileCopy(FName: String): Boolean; //    
function Use(D: TDataset): Boolean;
procedure DoSQL(S: String);
{$ENDIF}

implementation
{$IFDEF main}
uses Main;
{$ENDIF}

function  OS_isWindows95: boolean;  //true -    'Windows 95'
// 
begin
  if (GetVersion and $80000000) <> 0 then result:= true else result:= false;
end;

procedure SoundOff;
begin
  asm
    cli
    in      al,61h
    and     al,0fch
    out     61H,al
    sti
  end;
end;

procedure SoundOn;
begin
  asm
    cli
    in      al,61h
    or      al,3
    out     61H,al
    sti
  end;
end;

// Frequency -   ; Interval -   
procedure AsmBeep(Frequency: Word; Interval: Word);
var Period:Word;
begin
  if Frequency=0 then Frequency:=1;
  if Interval>10000 then Interval:=10000;
  if OS_isWindows95 then begin
    Period:=4194304 div Frequency;
    SoundOn;
    asm
      pushad
      cli
      mov     cx,Period
      in      al,61h
      or      al,3h
      out     61h,al
      mov     al,0b6h
      out     43h,al
      mov     al,cl
      out     42h,al
      mov     AL,ch
      out     42h,al
      sti
      popad
    end;
    Sleep(Interval);
    SoundOff;
  end else Windows.Beep(Frequency,Interval);
end;

procedure BeBeep(N: Integer);
var I: Integer;
begin
  case N of
  0: AsmBeep(2000,10);
  1: AsmBeep(2000,20);
  2: AsmBeep(2000,50);
  3: AsmBeep(5000,50);
  4: AsmBeep(10000,50);
  5: begin AsmBeep(2000,20); AsmBeep(1000,20); end;
  6: begin AsmBeep(2000,40); AsmBeep(1000,40); end;
  7: begin AsmBeep(2000,120); AsmBeep(500,100); AsmBeep(1000,100); end;
  8: for I:=1 to 6 do begin AsmBeep(1500,15); AsmBeep(5000,30); AsmBeep(12000,20); AsmBeep(5000,30); AsmBeep(1500,15); end;
  9: begin AsmBeep(2000,120); AsmBeep(500,100); AsmBeep(1000,100); AsmBeep(500,120); AsmBeep(1000,100); end;
  10: begin AsmBeep(500,120); AsmBeep(2000,100); AsmBeep(1000,100); AsmBeep(500,120); end;
  11: begin AsmBeep(2000,220); AsmBeep(500,200); AsmBeep(1000,200); AsmBeep(500,220); AsmBeep(1000,200); end;
  else begin AsmBeep(2000,120); AsmBeep(500,100); AsmBeep(1000,100); end;
  end;
end;

//       ( <-> )
function Revert(B: Byte): Byte;
begin
  asm
    mov  al,B
    mov  ecx,8
    @l1: rcl  al,1
         rcr  ah,1
         loop @l1
    mov  Result,ah
  end;
end;

function RMin(A,B: Real): Real;
begin
//  if A < B then Result := A else Result := B;
  asm
    mov   cl,byte ptr A+5   //  
    mov   ch,byte ptr B+5
    and   cx,8080h
    cmp   cl,ch
    jb    @m2               //   ?
    ja    @m1               //
    mov   al,byte ptr A     //  
    mov   ah,byte ptr B
    cmp   al,ah
    jb    @m3               //   ?
    ja    @m4               //
    mov   eax,dword ptr A+2 //   (     1.m) 4 ()  5  
    mov   edx,dword ptr B+2
    shl   eax,1
    shl   edx,1
    cmp   eax,edx
    ja    @m4
  @m3:
    or   cl,cl              //      
    jnz  @m2
  @m1:
    mov   eax,dword ptr A
    mov   dx,word ptr A+4
    jmp   @m5
  @m4:
    or   cl,cl              //      
    jnz  @m1
  @m2:
    mov   eax,dword ptr B
    mov   dx,word ptr B+4
  @m5:
    mov   dword ptr Result,eax
    mov   word ptr Result+4,dx
  end;
end;

function RMax(A,B: Real): Real;
begin
//  if A > B then Result := A else Result := B;
  if (RMin(A,B)=A) then Result:=B else Result:=A;
end;

procedure Mes(S: String);
begin
  MessageBox(Screen.ActiveForm.Handle,PChar(S),PChar(SMessageHeader),0);
end;

procedure Error(S: String);
begin
  MessageBox(Screen.ActiveForm.Handle,PChar(S),PChar(SErrorHeader),0);
end;

procedure NotRealised;
begin
  Mes(SOptionNotRealised);
end;

procedure DebugMes(S: string);
begin
  OutputDebugString(PChar(S));
end;

function iif(Flag: Boolean; Expr1,Expr2: Variant): Variant;
begin
  if Flag then Result:=Expr1 else Result:=Expr2;
end;

function LStr(S:String; Len:Integer): String;
begin
  Result:=S;
  if Length(S)>Len then SetLength(Result,Len);
end;

function RStr(S:String; Len:Integer): String;
var L,I: Integer;
begin
  L:=Length(S);
  if L<Len then Result:=S
  else begin
    Result:=''; SetLength(Result,Len);
    for I:=1 to Len do Result[I]:=S[L-Len+I]; end;
end;

procedure ExChange(var A,B: Pointer);
var C: Pointer;
begin
  C:=A; A:=B; B:=C;
end;

function RealToStr(R: Real; N, P: Integer): String;
begin
  Result:=RightStr(DelChars(ReplaceStr(FloatToStrF(R,ffNumber,15,P),',','.'),chr(160)),N);
end;

function Sub(A,B: DWord): Longint;
begin
  asm
    mov eax,A
    mov ecx,B
    sub eax,ecx
    mov Result,eax
  end;
end;

function Sign(N: Integer): Integer;
begin
  if N<0 then Result:=-1
         else if N>0 then Result:=1
                     else Result:=0;
end;

function Date2Str(Date: TDateTime): String;
const Month: array[1..12] of String=(SJanuary,SFebruary,SMarch,SApril,SMay,SJun,SJuly,SAugust,SSeptember,SOctober,SNovember,SDecember);
var Y,M,D: Word;
begin
  DecodeDate(Date,Y,M,D);
  Result:=IntToStr(D)+' '+Month[M]+' '+IntToStr(Y)+SOfYear;
end;

function Date2DayOfWeek(Date: TDateTime): String;
const DOW: array[1..7] of String=(SSunday,SMonday,STuesday,SWednesday,SThursday,SFriday,SSaturday);
begin
  Result:=DOW[DayOfWeek(Date)];
end;

function AStr(N:LongInt; Len:Integer): String;
begin
  Result:=RightStr(IntToStr(N),Len);
end;

function Zero(N:LongInt; Len:Integer): String;
begin
  Result:=ReplaceStr(RightStr(IntToStr(N),Len),' ','0');
end;

function TimeToScreen(D:Integer; T:LongInt): String;
var I,TT,TTT:LongInt; DD:Integer;
begin
  DD:=D; TT:=T;
  if TT<0 then begin TT:=TT+86400; DD:=DD-1; end;
  Result:=Zero(DD,2)+SShortDay;
  I:=TT div 3600;
  Result:=Result+Zero(I,2)+SShortHour;
  TTT:=TT-I*3600; I:=TTT div 60;
  Result:=Result+Zero(I,2)+SShortMinute+Zero(TTT mod 60,2)+SShortSecond;
end;

function DiskFreeSpace(D: String): LongInt;
var SectorsPerCluster, BytesPerSector, NumberOfFreeClusters, TotalNumberOfClusters: DWORD;
    S: PChar;
begin
  S:=PChar(D+'\');
  GetDiskFreeSpace(S, SectorsPerCluster, BytesPerSector, NumberOfFreeClusters, TotalNumberOfClusters);
  Result:=(NumberOfFreeClusters shr 10)*(SectorsPerCluster*BytesPerSector);
end;

function GetIDE_ID: DWord;
var MaximumComponentLength, FileSystemFlags, IDE_ID: DWORD;
begin
  GetVolumeInformation('C:\', nil, 0, @IDE_ID, MaximumComponentLength, FileSystemFlags, nil, 0);
  Result:=IDE_ID;
end;

function CaseOf(I: Integer; T1,T2,T3,T4: TObject): TObject;
begin
  case I of
  0: Result:=T1;
  1: Result:=T2;
  2: Result:=T3;
  3: Result:=T4;
  end;
end;

function GetChar: Char;
begin
  WaitFlag:=True;
  while WaitFlag and not ExitFlag do Application.ProcessMessages;
end;

function GetKey: Word;
begin
  WaitFlag:=True;
  while WaitFlag and not ExitFlag do Application.ProcessMessages;
end;

procedure AddFilterString(var F: String; S: String);
begin
  if F='' then F:=S else F:=F+' and '+S;
end;

function ByteToStr(Value: Byte): String;
var I: Integer; X,Mask: Byte;
begin
  Result:=''; Mask:=1 shl 7;
  for I:=1 to 8 do begin
    X:=iif(Value and Mask<>0,1,0);
    Result:=Result+IntToStr(X);
    Mask:=Mask shr 1; end;
end;

procedure BitmapToPaintBox(BMP: TBitmap; PB: TPaintBox);
begin
  if (BMP=nil) or (PB=nil) or (PB.Canvas.Handle=0) then exit;
  try
  if (PB.Width=BMP.Width) and (PB.Height=BMP.Height)
    then PB.Canvas.Draw(0,0,BMP)
    else PB.Canvas.StretchDraw(Rect(0,0,PB.Width,PB.Height),BMP);
  except end;
end;

function ToColor5(W: Word):Byte;
begin
  asm
    mov AX,W
    and AL,11111b
    mov @Result,AL
  end
end;

function FromColor5(B: Byte):Word;
begin
  asm
    xor AX,AX
    mov DL,B
    and DL,11111b
    or  AL,DL
    shl AX,5
    or  AL,DL
    shl AX,5
    or  AL,DL
    mov @Result,AX
  end
end;

function Color2Gray(C:TColor):Byte;
begin
  Result:=(TByteRec(TWordRec(C).Hi).Lo
          +TByteRec(TWordRec(C).Lo).Hi
          +TByteRec(TWordRec(C).Lo).Lo) div 3;
end;

function Gray2Color(C:Byte):TColor;
begin
  TByteRec(TWordRec(Result).Hi).Hi:=0;
  TByteRec(TWordRec(Result).Hi).Lo:=C;
  TByteRec(TWordRec(Result).Lo).Hi:=C;
  TByteRec(TWordRec(Result).Lo).Lo:=C;
end;

function RusString(S: String): String;
const Rus: array [0..11] of string = ('', '', '', '', '', '', '', '', '', '', '', '');
      Lat: array [0..11] of string = ('K', 'E', 'H', 'X', 'B', 'A', 'P', 'O', 'C', 'M', 'T', 'Y');
var i: Integer;
begin
  for i:=0 to 11 do S:=ReplaceStr(S, Lat[i], Rus[i]);
  Result:=S;
end;

//  
function TranslitToRus(S: String): String;
var Lat: array[1..48] of char;//='ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz';
    Rus: array[1..48] of char;//='';
    i: Integer;
begin
  for i:=0 to 11 do S:=ReplaceStr(S, Lat[i], Rus[i]);
  Result:=S;
end;

function Crypt(IntKey: LongInt; StrKey, S: String): String;
var I,X,L: Integer;
begin
  X:=37*Lo(IntKey); L:=Length(StrKey);
  for I:=1 to L do X:=X+Ord(StrKey[I]);
  L:=Length(S);
  if (L=0) then begin Result:=''; exit; end;
  SetLength(Result,L);
  for I:=1 to L do Result[I]:=Chr(Ord(S[I]) xor Lo(X+X*I+I));
end;

//       BMP2 ,    BMP1
procedure TestBitmapEquivalence(BMP1,BMP2: TBitmap);
var PF: TPixelFormat;
    W,H: Longint;
begin
  W:=BMP1.Width; H:=BMP1.Height; PF:=BMP1.PixelFormat;
  if BMP2.PixelFormat<>PF then BMP2.PixelFormat:=PF;
  if BMP2.Width<>W then BMP2.Width:=W;
  if BMP2.Height<>H then BMP2.Height:=H;
end;

function BitmapIsEmpty(BMP: TBitmap): Boolean;
var K,W,KW,H: Integer; P: Pointer;
begin
  Result:=True;
  case BMP.PixelFormat of
    pf15bit,pf16bit: K:=2;
    pf24bit: K:=3;
    pf32bit: K:=4;
    else K:=1;
  end;
  W:=BMP.Width;
  H:=BMP.Height;
  P:=BMP.ScanLine[H-1];
  K:=(Integer(BMP.ScanLine[H-2])-Integer(P)) div W;
  KW:=K*W;
  asm
    pushfd
    pushad
    cld
    mov  ebx,P
    mov  edx,[ebx] //  1- () ,      ()
    mov  ecx,H
    @l1: push ecx
         mov  esi,ebx
         mov  ecx,W
         cmp  K,1
         je   @l4
         cmp  K,2
         je   @l3
         @l2: lodsd
              mov  dh,dl
              sub  al,dh
              jnc  @m3
              neg  al
         @m3: cmp  al,5
              ja   @m2
              dec  esi
              loop @l2
         jmp  @m5
         @l3: lodsw
              mov  dh,dl
              and  dh,00011111b
              and  al,00011111b
              sub  al,dh
              jnc  @m4
              neg  al
         @m4: cmp  al,1
              ja   @m2
              loop @l3
         jmp  @m5
         @l4: lodsb
              mov  dh,dl
              sub  al,dh
              jnc  @m6
              neg  al
         @m6: cmp  al,5
              ja   @m2
              loop @l4
         jmp  @m5
    @m2: pop  ecx
         jmp  @l_ex
    @m5: add  ebx,KW
         pop  ecx
         loop @l1
    jmp  @m1
@l_ex:
    mov  Result,0   // False
@m1:popad
    popfd
  end;
end;

//  BMP1  BMP2
procedure CopyBMP(BMP1,BMP2: TBitmap);
var BitmapLength: Longint;
begin
  TestBitmapEquivalence(BMP1,BMP2);
  with BMP1 do begin
    BitmapLength:=(Integer(ScanLine[0])-Integer(ScanLine[1]))*Height;
    Move(ScanLine[Height-1]^,BMP2.ScanLine[Height-1]^,BitmapLength);
  end;
end;

procedure CopyBitmap(SourceBMP, DestBMP: TBitmap);
var PSrc, PDest: Pointer; Len: LongInt;
begin
  with SourceBMP do if (Width>0) and (Height>0) and (Width<=MaxXSize) and (Height<=MaxYSize) then begin
    DestBMP.Height:=Height; DestBMP.Width:=Width;
    PSrc:=ScanLine[Height-1];
    PDest:=DestBMP.ScanLine[Height-1];
    Len:=((Integer(ScanLine[Height-2])-Integer(ScanLine[Height-1])) shr 2)*Height;
//    Len:=iif(Form1.HighColor.Checked,3,2)*(Width shr 2)*Height;
    asm
      pushfd
      pushad
      cld
      mov  esi,PSrc
      mov  edi,PDest
      mov  ecx,Len
      rep  movsd
      popad
      popfd
    end; end;
end;

procedure SetRus;
var Layout: array[0.. KL_NAMELENGTH] of char;
begin
  LoadKeyboardLayout( StrCopy(Layout,'00000419'),KLF_ACTIVATE);
end;

procedure SetEng;
var Layout: array[0.. KL_NAMELENGTH] of char;
begin
  LoadKeyboardLayout(StrCopy(Layout,'00000409'),KLF_ACTIVATE);
end;

procedure ClearTimeArray;
var I,J,K: Integer;
begin
{$IFDEF TimeCount}
  if not TimeCount then exit;
  for I:=1 to 10 do
    for J:=1 to 30 do begin
      TimeProc[I,J]:='';
      for K:=0 to 8 do TimeArray[I,J,K]:=0; end;
{$ENDIF}
end;

procedure ProcEnter(ProcName: String);
var I: Integer; S: String;
begin
{$IFDEF TimeCount}
  if not TimeCount then exit;
  TimeLevel:=TimeLevel+1;
  for I:=1 to 30 do begin
    S:=TimeProc[TimeLevel,I];
    if (S=ProcName) or (S='') then break; end;
  if S='' then TimeProc[TimeLevel,I]:=ProcName;
  TimeThread[TimeLevel]:=I;
  Inc(TimeArray[TimeLevel,I,3]);
  TimeArray[TimeLevel,I,6]:=0;
  TimeArray[TimeLevel,I,0]:=GetTickCount;
{$ENDIF}
end;

procedure ProcExit(ProcName: String);
var I: Integer; S: String; T,T0: Longint;
begin
{$IFDEF TimeCount}
  if not TimeCount then exit;
  if TimeLevel<=0 then begin S:=ProcName; exit; end;
  I:=TimeThread[TimeLevel];
  T0:=Sub(GetTickCount,TimeArray[TimeLevel,I,0]);
  if TimeLevel>1 then
    TimeArray[TimeLevel-1,TimeThread[TimeLevel-1],6]:=TimeArray[TimeLevel-1,TimeThread[TimeLevel-1],6]+T0;
  TimeArray[TimeLevel,I,0]:=T0;
  if (TimeArray[TimeLevel,I,4]=0) or (T0<TimeArray[TimeLevel,I,4])
    then TimeArray[TimeLevel,I,4]:=T0;
  if T0>TimeArray[TimeLevel,I,5]
    then TimeArray[TimeLevel,I,5]:=T0;
  TimeArray[TimeLevel,I,1]:=TimeArray[TimeLevel,I,1]+T0;
  T:=T0-TimeArray[TimeLevel,I,6];
  TimeArray[TimeLevel,I,2]:=TimeArray[TimeLevel,I,2]+T;
  if (TimeArray[TimeLevel,I,7]=0) or (T<TimeArray[TimeLevel,I,7])
    then TimeArray[TimeLevel,I,7]:=T;
  if T>TimeArray[TimeLevel,I,8]
    then TimeArray[TimeLevel,I,8]:=T;
  TimeLevel:=TimeLevel-1;
{$ENDIF}
end;

procedure ShowTimeArray(M: TRichEdit);
var I,J: Integer;
begin
{$IFDEF TimeCount}
  if not TimeCount then exit;
  with M do begin
    Clear;
    SelAttributes.Color:=clBlack;
    Lines.Add(' ProcName          LastT. Sum Sum-Ch Times  Medium  Med-Ch MinT. MaxT. Min-Ch Max-Ch');
    Lines.Add('-------------------------------------------------------------------------------------');
    for I:=1 to 10 do begin
      SelAttributes.Color:=Colors[I];
      for J:=1 to 30 do
        if TimeProc[I,J]<>'' then Lines.Add(LeftStr(TimeProc[I,J],18)+
                                  RightStr(IntToStr(TimeArray[I,J,0]),6)+
                                  RightStr(IntToStr(TimeArray[I,J,1]),6)+
                                  RightStr(IntToStr(TimeArray[I,J,2]),6)+
                                  RightStr(IntToStr(TimeArray[I,J,3]),6)+
                                  RealToStr(TimeArray[I,J,1]/TimeArray[I,J,3],8,2)+
                                  RealToStr(TimeArray[I,J,2]/TimeArray[I,J,3],8,2)+
                                  RightStr(IntToStr(TimeArray[I,J,4]),6)+
                                  RightStr(IntToStr(TimeArray[I,J,5]),6)+
                                  RightStr(IntToStr(TimeArray[I,J,7]),7)+
                                  RightStr(IntToStr(TimeArray[I,J,8]),7)); end; end;
{$ENDIF}
end;

procedure AppendLog(S: String);
var S1: String;
begin
  {$I-}
  try
    {$IFDEF ReOpeningJournalFile}
      if FileExists(JournalFileName) and (GetFileSize(JournalFileName)>10*Mb) then
        try
          S1:=ReplaceStr(JournalFileName,'txt','old');
          DeleteFile(S1);
          RenameFile(JournalFileName,S1);
        except
        end;
      AssignFile(JournalFile,JournalFileName);
      if FileExists(JournalFileName) then Append(JournalFile) else Rewrite(JournalFile);
    {$ENDIF}
    S:=DateTimeToStr(Now)+' '+S;
    Writeln(JournalFile,S);
    Flush(JournalFile);
  except
  end;
  {$IFDEF ReOpeningJournalFile}
    CloseFile(JournalFile);
  {$ENDIF}
  {$I+}
end;

procedure CopyDir(SrcDir,DestDir: String);
var SearchRec: TSearchRec; Founded: Integer; FileName: String;
begin
  if SrcDir[Length(SrcDir)]<>'\' then SrcDir:=SrcDir+'\';
  if DestDir[Length(DestDir)]<>'\' then DestDir:=DestDir+'\';
  Founded:=FindFirst(SrcDir+'*.*', faAnyFile, SearchRec);
  while (Founded=0) do begin
    FileName:=ExtractFileName(SearchRec.Name);
    if (FileName<>'.') and (FileName<>'..') then
      try CopyFile(SrcDir+FileName,DestDir+FileName,nil); except end;
    Founded:=FindNext(SearchRec);
  end;
  FindClose(SearchRec);
end;

{$IFDEF DBFunctions}
function NullFileCopy(FName: String): Boolean; //    
var NullFileName, FileName: String; CapFlag: Boolean; S: String; SearchRec: TSearchRec; Founded: Integer;
begin
  Result:=True;
  {$IFDEF Main}Form1.WriteEvent('ErrorMes',0,3,'Use-NullFileCopy: '+FName);{$ENDIF}
  S:=UpperCase(FName); CapFlag:=((S='CAPTURE') or ((LStr(S,3)='CAP') and (S[4]>='0') and (S[4]<='9')));
  Founded:=FindFirst(NullDir+iif(CapFlag,'capture.*',FName+'.*'), faAnyFile, SearchRec);
  if (Founded<>0) then Error(SRecoverError+NullFileName+' !');
  while (Founded=0) do begin
    NullFileName:=NullDir+SearchRec.Name;
    FileName:=BaseDir+FName+ExtractFileExt(NullFileName);
    try
      CopyFile(NullFileName,FileName,nil);
      if UpperCase(FName)='RECORD' then RecordPured:=True;
    except
      Error(SRecoverCopyError+FileName+' (: '+NullFileName+') !');
      Result:=False;
    end;
    Founded:=FindNext(SearchRec);
  end;
  FindClose(SearchRec);
end;

function Use(D: TDataset): Boolean;
var S,S1,FileName,FName,NullFileName,UniCodeFieldName,UniCodeName: String; Pos: Integer; TT: TTable; TF: TIntegerField;
    KeyViolationError: Boolean; I,J: Integer; FF: Boolean;
begin
  Result:=False;
  if D.Active then D.Close;
  TDBDataset(D).DatabaseName:=BaseDir;
  if (D is TTable) then with TTable(D) do //    
    FileName:=TTable(D).TableName
  else if (D is TQuery) then with TQuery(D) do begin
    S1:=TQuery(D).SQL.Text;
    FileName:=DelChars(ExtractWord(1,Copy(S1,NPos(' FROM ',UpperCase(S1),1)+5,1000),[' ',#10,#13]),'"');
  end;
  if NPos('.',FileName,1)=0 then FileName:=FileName+'.db';
  FName:=ExtractWord(1,FileName,['.']);
  if not FileExists(BaseDir+FileName) then NullFileCopy(FName); //   ,  
  try
//    if ReIndexOnOpen and (TComponent(D).Tag=1) and FileExists(BaseDir+FName+'.px') then raise Exception.Create('PrevClosedOk=False');
    if (D is TQuery) then TQuery(D).Prepare;
    FF:=D.Filtered;
    D.Open;
    if (D is TTable) and not TTable(D).ReadOnly and (D.Fields[0] is TAutoIncField) then
      try //     
        D.Filtered:=False;
        D.Append;
        D.Post;
        if D.RecordCount<>0 then D.Delete;
        D.Filtered:=FF;
      except
        on E: Exception do begin
          {$IFDEF Main}Form1.WriteEvent('ErrorMes',0,3,'Use-Append: '+FileName+'('+TComponent(D).Name+'): '+E.Message);{$ENDIF}
          D.Close;
          D.Filtered:=FF;
          raise
        end;
      end;
  except //      
    on E: Exception do begin
      {$IFDEF Main}Form1.WriteEvent('ErrorMes',0,3,'Use-Open: '+FileName+'('+TComponent(D).Name+'): '+E.Message);{$ENDIF}
      if FileExists(BaseDir+FName+'.px') then begin
        UniCodeFieldName:=D.Fields[0].FieldName;
        UniCodeName:=D.Fields[0].Name;
        TT:=TTable.Create(nil);
        with TT do begin
         {$IFDEF Main}Form1.WriteEvent('ErrorMes',0,3,'Use-ReIndexation: '+FileName+'('+TComponent(D).Name+')');{$ENDIF}
          try
            if DeleteFiles(BaseDir+FName+'.px') then begin
              DataBaseName:=BaseDir;
              TableName:=FileName;
              Exclusive:=True;
              Open;
              AddIndex('',UniCodeFieldName,[ixPrimary,ixUnique]);
              Result:=True;
            end;
          except
            {$IFDEF Main}on E: Exception do Form1.WriteEvent('ErrorMes',0,3,'Use-ReIndex: '+FileName+'('+TComponent(D).Name+'): '+E.Message);{$ENDIF}
          end;
          Close; Free;
        end;
      end;
      if not Result then NullFileCopy(FName); //   ,  -   
      try D.Open; I:=0;
        if (D is TTable) and (D.Fields[0] is TAutoIncField) then begin
          D.Filtered:=False;
          while True do with D do
            try //     ,  ,    100  ,   
              Append;
              Post;
              if RecordCount<>0 then Delete;
              break; //    /,    
            except
              Inc(I); Last; Delete;
              S:='';
              for J:=0 to D.FieldCount-1 do
                if (D.Fields[J]<>nil) and (D.Fields[J].Value<>Null) then S:=S+D.Fields[J].AsString+' ';
              S:=LeftStr(S,150);
              {$IFDEF Main}Form1.WriteEvent('ErrorMes',0,3,'Use-DelRec: '+FileName+'('+TComponent(D).Name+'): "'+S+'"');{$ENDIF}
              if I=100 then begin
                try D.Filtered:=FF; except end;
                raise
              end;
            end;
          try D.Filtered:=FF; except end;
        end;
      except
        {$IFDEF Main}on E: Exception do Form1.WriteEvent('ErrorMes',0,3,'Use-Open2: '+FileName+'('+TComponent(D).Name+'): '+E.Message);{$ENDIF}
      end;
    end;
  end;
  Result:=D.Active;
end;

procedure DoSQL(S: String);
var Q: TQuery;
begin
  Q:=TQuery.Create(nil);
  with Q, Q.SQL do begin
    DatabaseName:=BaseDir;
    Add(S);
    try
      Prepare;
      ExecSQL;
      UnPrepare;
    except
    end;
    Free;
  end;
end;
{$ENDIF}

end.
